// tslint:disable-next-line:no-reference
/// <reference path="../../node_modules/reflect-metadata/index.d.ts" />
import { GraphQLInterfaceType } from 'graphql';
import { GRAPHQL_OBJECT_TYPE, GRAPHQL_OBJECT_TYPE_CONFIG, GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE, getObjectTypeFromClass } from './object-type';
export function InterfaceType(config = {}) {
    return target => {
        const existingGraphQLObjectTypeQueue = Reflect.getMetadata(GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE, target) || [];
        existingGraphQLObjectTypeQueue.push(() => {
            const existingConfig = Reflect.getMetadata(GRAPHQL_OBJECT_TYPE_CONFIG, target) || {};
            Reflect.defineMetadata(GRAPHQL_OBJECT_TYPE, new GraphQLInterfaceType(Object.assign({ name: config.name || target.name, resolveType: function (root, ...args) {
                    const fieldType = config.resolveType.call(root, root, ...args);
                    return getObjectTypeFromClass(fieldType) || fieldType;
                } }, existingConfig)), target);
        });
        Reflect.defineMetadata(GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE, existingGraphQLObjectTypeQueue, target);
        return target;
    };
}
//# sourceMappingURL=interface-type.js.map