import { GraphQLUnionType } from 'graphql';
import { getScalarTypeFromClass } from './scalar-type';
import { GRAPHQL_OBJECT_TYPE } from './object-type';
export function UnionType(config) {
    return (target) => {
        Reflect.defineMetadata(GRAPHQL_OBJECT_TYPE, new GraphQLUnionType({
            name: config.name,
            resolveType: (...args) => {
                const type = config.resolveType(...args);
                return Reflect.getMetadata(GRAPHQL_OBJECT_TYPE, type) || getScalarTypeFromClass(type) || type;
            },
            types: config.types.map(type => Reflect.getMetadata(GRAPHQL_OBJECT_TYPE, type) || getScalarTypeFromClass(type) || type),
        }), target);
        return target;
    };
}
//# sourceMappingURL=union-type.js.map