"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const scalar_type_1 = require("./scalar-type");
function EnumType(config = {}) {
    return (target) => {
        const values = {};
        // tslint:disable-next-line:forin
        for (const key in target) {
            values[key] = {
                value: key,
            };
        }
        Reflect.defineMetadata(scalar_type_1.GRAPHQL_SCALAR_TYPE, new graphql_1.GraphQLEnumType(Object.assign({ values }, config)), target);
        return target;
    };
}
exports.EnumType = EnumType;
//# sourceMappingURL=enum-type.js.map