import { GraphQLObjectType, GraphQLInputType } from 'graphql';
import { Type, AnyType, MaybeArray } from './common';
export declare const GRAPHQL_OBJECT_TYPE_CONFIG = "graphql:object-type-config";
export declare const GRAPHQL_OBJECT_TYPE = "graphql:object-type";
export declare const GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE = "graphql-object-type-build-queue";
export declare const CONTEXT_INJECTOR_FACTORY = "context-injector:factory";
export declare const PROPERTY_KEYS = "property-keys";
export interface ArgDecoratorConfig<TResult> {
    type?: Type<TResult> | GraphQLInputType | object;
    nullable?: boolean;
}
export declare function Arg<TSource, TContext, TResult>(argumentName: string, config?: ArgDecoratorConfig<TResult>): ParameterDecorator;
export interface FieldDecoratorConfig {
    name?: string;
    nullable?: boolean;
}
export declare function Field<TSource, TContext, TArgs, TResult>(typeFactory?: (type: void) => Type<TResult> | GraphQLObjectType | AnyType | unknown, config?: FieldDecoratorConfig): (target: TSource, propertyKey: string) => void;
export declare function Inject(serviceIdentifier?: any): PropertyDecorator;
export interface Injector {
    get<T>(serviceIdentifier: any): T;
}
export declare type ContextInjectorFactory<TContext> = (context: TContext) => Injector;
export interface ObjectTypeDecoratorConfig<TResult, TContext> {
    name?: string;
    implements?: MaybeArray<Type<TResult> | GraphQLObjectType | AnyType | unknown>;
    injector?: ContextInjectorFactory<TContext> | Injector;
}
export declare function ObjectType<TSource, TResult, TContext>(config?: ObjectTypeDecoratorConfig<TResult, TContext>): ClassDecorator;
export declare function getObjectTypeFromClass<T>(target: Type<T> | unknown): any;
