"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const scalar_type_1 = require("./scalar-type");
const object_type_1 = require("./object-type");
function UnionType(config) {
    return (target) => {
        Reflect.defineMetadata(object_type_1.GRAPHQL_OBJECT_TYPE, new graphql_1.GraphQLUnionType({
            name: config.name,
            resolveType: (...args) => {
                const type = config.resolveType(...args);
                return Reflect.getMetadata(object_type_1.GRAPHQL_OBJECT_TYPE, type) || scalar_type_1.getScalarTypeFromClass(type) || type;
            },
            types: config.types.map(type => Reflect.getMetadata(object_type_1.GRAPHQL_OBJECT_TYPE, type) || scalar_type_1.getScalarTypeFromClass(type) || type),
        }), target);
        return target;
    };
}
exports.UnionType = UnionType;
//# sourceMappingURL=union-type.js.map